#!/usr/bin/perl

########################################
# Script by Matt of Bumderland
# http://www.bumderland.com
# bookbaghead@hotmail.com
########################################

########################################
# Display Header
########################################
print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document

########################################
# Get Variables from Form
########################################
if($ENV{'CONTENT_LENGTH'} > 3)
{
	read (STDIN, $unformatted, $ENV{'CONTENT_LENGTH'});  #  stores the unformated form data
	@pairs = split(/&/,$unformatted);  #  splits up each pair (name=value)
	foreach $pair(@pairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		$form{lc($name)} = "$value";  #  defines form field
	}
}

########################################
# Check Password and Load Page Accordingly
########################################
$pass = crypt($form{'password'}, "MM");
open(USERS, "jxzdfx.dat");
$users = <USERS>;
close(USERS);
%users = split(/\,/,$users);
if($users{$form{'name'}} ne $pass)
{
	print "<html><head><title>Log-in Failed</title></head><body>Your username and/or password are invalid.</body></html>";
}
else
{
########################################
# Read Universal Settings  (for help files)
########################################
open(SET,"uniset.dat");
$set = <SET>;
close(SET);
@unisettings = split(/,/,$set);
$help=$unisettings[2];

########################################
# Get Field Data
########################################
open(FIELDS,"$form{'game'}fields.dat");
$properties = <FIELDS>;
close(FIELDS);
($fields,$properties) = split(/\|/,$properties);
@fields = split(/,/,$fields);
@properties = split(/,/,$properties);
$count = 0;
foreach $field (@fields)
{
	$properties{$field} = $properties[$count];
	$number{$field} = $count;  #  I need to know the numbers of cerain fields.
$count++;
}
@properties = ();

########################################
# Read Databases
########################################
open(CHEAT, "$form{'game'}cheaters.dat");
while(<CHEAT>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@scores,$row);
}
close(CHEAT);

########################################
# Sort Scores
########################################
if(!(exists $form{'sort'})){$form{'sort'} = $fields[0];}
$sort = $form{'sort'};  #A change in the sort algorithms requires this
if($properties{$form{'sort'}} == 0)
{
	if(substr($form{'order'},0,1) eq "a")
	{
		@scores = reverse sort sort_strings @scores;
	}
	else
	{
		@scores = sort sort_strings @scores;
	}
}
else
{
	if(substr($form{'order'},0,1) eq "d")
	{
		@scores = reverse sort sort_numbers @scores;
	}
	else
	{
		@scores = sort sort_numbers @scores;
	}
}

########################################
# Remove Unneeded Keys
########################################
$game = $form{'game'};
delete $form{'game'};
$name = $form{'name'};
delete $form{'name'};
$password = $form{'password'};
delete $form{'password'};
$submit = $form{'submit'};
delete $form{'submit'};
$sort = $form{'sort'};
delete $form{'sort'};
$order = $form{'order'};
delete $form{'order'};

########################################
# Delete Scores
########################################
@entries =  keys(%form);
if($submit eq "Delete")
{
	#Sort @entries
	@entries = sort sort_numbers_normal @entries;
	#Remove Scores
	for( ; scalar(@entries) > 0; )
	{
		$entry = shift(@entries);
		splice(@scores,$entry,1);
	}
	#Sort
	$sort = $fields[0];
	if($properties{$fields[0]} == 1)
	{
		@scores = sort sort_numbers @scores;
	}
	else
	{
		@scores = sort sort_strings @scores;
	}
	open(CHEAT, ">".$game."cheaters.dat");
	foreach $score (@scores)
	{
		print CHEAT "$score\n";
	}
	close(CHEAT);
########################################
# Read and display page
########################################
	$title = "Cheaters Deleted";
	open(PAGE, "nav.dat");
	while(<PAGE>)
	{
		$row = $_;
		$chopped = chop($row);
		if($chopped ne "\n")
			{$row = $row.$chopped;}
		$page = $page."$row\n";
	}
	close(PAGE);
	eval($page);
}
}  #  Ends else statement

########################################
# Sort Subroutines
########################################
sub sort_strings
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return (uc($AArray[$number{$sort}]) cmp uc($BArray[$number{$sort}]));
}

sub sort_numbers
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return ($BArray[$number{$sort}] <=> $AArray[$number{$sort}]);
}

sub sort_numbers_normal
{
	return $b <=> $a;
}