#!/usr/bin/perl

########################################
# Script by Matt of Bumderland
# http://www.bumderland.com
# bookbaghead@hotmail.com
########################################

########################################
# Display Header
########################################
print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document

########################################
# Get Variables from Form
########################################
if($ENV{'CONTENT_LENGTH'} > 3)
{
	read (STDIN, $unformatted, $ENV{'CONTENT_LENGTH'});  #  stores the unformated form data
	@pairs = split(/&/,$unformatted);  #  splits up each pair (name=value)
	foreach $pair(@pairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		$form{lc($name)} = "$value";  #  defines form field
	}
}

########################################
# Check Password and Load Page Accordingly
########################################
$pass = crypt($form{'password'}, "MM");
open(USERS, "jxzdfx.dat");
$users = <USERS>;
close(USERS);
%users = split(/\,/,$users);
if($users{$form{'name'}} ne $pass)
{
	print "<html><head><title>Log-in Failed</title></head><body>Your username and/or password are invalid.</body></html>";
}
else
{
	# Read Universal Settings  (for help files)
	open(SET,"uniset.dat");
	$set = <SET>;
	close(SET);
	@unisettings = split(/,/,$set);
	$help=$unisettings[2];
	#Do normal stuff
	$form{'game'} = lc($form{'game'});
	$form{'game'} =~ s/ //g;  #  Filter out spaces
	$form{'game'} =~ s/\"//g;  #No quotes!
	if(($form{'game'} eq "") || (-e "$form{'game'}/scores.dat") || ($form{'game'} =~ m/\./))
	{
		print "<html><head><title>Invalid Name</title></head><body>You either did not enter a name, entered a name that already exists, or entered a name with a period.</body></html>";
		goto End;
	}
	mkdir($form{'game'},0755);
	$form{'game'} = $form{'game'}."/";
	if($form{'copy'} == 1)
	{
		#open refer.dat
		open(Refer, "refer.dat");
		$refer = <Refer>;
		close(Refer);
		#save refer.dat
		open(Refer, ">".$form{'game'}."refer.dat");
		print Refer "$refer";
		close(Refer);
		#open set.dat
		open(SET,"set.dat");
		$set = <SET>;
		close(SET);
		#save set.dat
		open(SET,">".$form{'game'}."set.dat");
		print SET "$set";
		close(SET);
		#open check.dat
		open(SECURE,"check.dat");
		while(<SECURE>)
		{
			$row = $_;
			$chopped = chop($row);
			if($chopped ne "\n")
				{$row = $row.$chopped;}
			$secure = $secure."$row\n";
		}
		close(SECURE);
		#save check.dat
		open(SECURE,">".$form{'game'}."check.dat");
		print SECURE "$secure";
		close(SECURE);
		#open ent.dat
		open(PAGE, "ent.dat");
		$page = <PAGE>;
		close(PAGE);
		#save ent.dat
		open(PAGE, ">".$form{'game'}."ent.dat");
		print PAGE "$page";
		close(PAGE);
		#open aent.dat
		open(PAGE, "aent.dat");
		$page = <PAGE>;
		close(PAGE);
		#save aent.dat
		open(PAGE, ">".$form{'game'}."aent.dat");
		print PAGE "$page";
		close(PAGE);
		#open main.dat
		open(PAGE, "main.dat");
		$page = <PAGE>;
		close(PAGE);
		#save main.dat
		open(PAGE, ">".$form{'game'}."main.dat");
		print PAGE "$page";
		close(PAGE);
		#open amain.dat
		open(PAGE, "amain.dat");
		$page = <PAGE>;
		close(PAGE);
		#save amain.dat
		open(PAGE, ">".$form{'game'}."amain.dat");
		print PAGE "$page";
		close(PAGE);
		#open fields.dat
		open(FIELDS,"fields.dat");
		$fields = <FIELDS>;
		close(FIELDS);
		#save fields.dat
		open(FIELDS,">".$form{'game'}."fields.dat");
		print FIELDS "$fields";
		close(FIELDS);
		#open addons.dat
		open(ADDONS,"addons.dat");
		while(<ADDONS>)
		{
			$row = $_;
			$chopped = chop($row);
			if($chopped ne "\n")
				{$row = $row.$chopped;}
			$addons = $addons."$row\n";
		}
		close(ADDONS);
		#save addons.dat
		open(ADDONS,">".$form{'game'}."addons.dat");
		print ADDONS "$addons";
		close(ADDONS);
	}
	else
	{
		open(FILE,">".$form{'game'}."refer.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."set.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."check.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."ent.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."main.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."aent.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."amain.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."fields.dat");
		close(FILE);
		open(FILE,">".$form{'game'}."addons.dat");
		close(FILE);
	}	
	open(FILE,">".$form{'game'}."scores.dat");
	close(FILE);
	open(FILE,">".$form{'game'}."ascores.dat");
	close(FILE);
	open(FILE,">".$form{'game'}."cheaters.dat");
	close(FILE);
	@files = ($form{'game'}."refer.dat",
			  $form{'game'}."set.dat",
			  $form{'game'}."check.dat",
			  $form{'game'}."ent.dat",
			  $form{'game'}."main.dat",
			  $form{'game'}."aent.dat",
			  $form{'game'}."amain.dat",
			  $form{'game'}."fields.dat",
			  $form{'game'}."scores.dat",
			  $form{'game'}."ascores.dat",
			  $form{'game'}."cheaters.dat",
			  $form{'game'}."addons.dat");
	chmod(0622,@files);
########################################
# Read and display page
########################################
	$title = "New Game Created";
	$page = "";
	open(PAGE, "nav.dat");
	while(<PAGE>)
	{
		$row = $_;
		$chopped = chop($row);
		if($chopped ne "\n")
			{$row = $row.$chopped;}
		$page = $page."$row\n";
	}
	close(PAGE);
	eval($page);
}

END: