#!/usr/bin/perl

########################################
# Script by Matt of Bumderland
# http://www.bumderland.com
# bookbaghead@hotmail.com
########################################

########################################
# Display Header
########################################
print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document

########################################
# Get Variables from Form
########################################
if($ENV{'CONTENT_LENGTH'} > 3)
{
	read (STDIN, $unformatted, $ENV{'CONTENT_LENGTH'});  #  stores the unformated form data
	@pairs = split(/&/,$unformatted);  #  splits up each pair (name=value)
	foreach $pair(@pairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		$form{lc($name)} = "$value";  #  defines form field
	}
}

########################################
# Check Password and Load Page Accordingly
########################################
$pass = crypt($form{'password'}, "MM");
open(USERS, "jxzdfx.dat");
$users = <USERS>;
close(USERS);
%users = split(/\,/,$users);
if($users{$form{'name'}} ne $pass)
{
	print "<html><head><title>Log-in Failed</title></head><body>Your username and/or password are invalid.</body></html>";
}
else
{
########################################
# Get Current Field Data
########################################
open(FIELDS,"$form{'game'}fields.dat");
$properties = <FIELDS>;
close(FIELDS);
($fields,$properties) = split(/\|/,$properties);
@fields = split(/,/,$fields);
@properties = split(/,/,$properties);
$count = 0;
foreach $field (@fields)
{
	$properties{$field} = $properties[$count];
	$number{$field} = $count;  #  I need to know the numbers of cerain fields.
	$count++;
}
@properties = ();

########################################
# Prepare for Saving
########################################
for($count = 0; exists($form{$count}); $count++)
{
	if($form{$count} ne "")
	{
		$form{$count} =~ s/\"//g;
		push(@nfields,lc($form{$count}));
		push(@nproperties,$form{'t'.$count});
		if($form{"c".$count} ne "")  #Handles name changes
		{
			$fields[$number{$form{"c".$count}}] = $form{$count};
			$properties{$form{$count}} = $form{'t'.$count};
		}
		if($form{"d".$count} ne "")  #Handles default entries
		{
			$entry{$form{$count}} = $form{"d".$count};
		}
	}
}
$field = join(",",@nfields);
$property = join(",",@nproperties);
$final = "$field\|$property";

########################################
# Check for Invalid Field Names
########################################
foreach $fields(@nfields)
{
	if(($fields eq "name") || ($fields eq "type") || ($fields eq "sort") || ($fields eq "game") || ($fields eq "order") || ($fields eq "password") || ($fields eq "submit"))
	{
		print "<html><head><title>Bad Boy!</title></head><body>You have used an invalid field name.  Field names may not be:<li>name<li>password<li>game<li>type<li>sort<li>order<li>submit</body></html>";
		exit;
	}
}

########################################
# Save
########################################
open(FIELDS,">".$form{'game'}."fields.dat");
print FIELDS $final;
close(FIELDS);

########################################
# Reformat scores
########################################
# Read Databases
open(SCORES, "$form{'game'}scores.dat");
while(<SCORES>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@scores,$row);
}
close(SCORES);
@nscores = ();
foreach $score (@scores)
{
	@pieces = split(/\|/,$score);
	foreach $field (@fields)
	{
		$entry{$field} = $pieces[$number{$field}];
		#print $field."=".$pieces[$number{$field}]."<br>";
	}
	#print "<P>";
	push(@nscores,&prepare_entry);
}
@scores = @nscores;
@nscores = ();
#Sort
if($properties{$fields[0]} == 1)
{
	@scores = sort sort_numbers @scores;
}
else
{
	@scores = sort sort_strings @scores;
}
#Save
open(SCORES, ">".$form{'game'}."scores.dat");
foreach $score (@scores)
{
	print SCORES "$score\n";
}
close(SCORES);

#All-time Scores
# Read Databases
@scores = ();
open(SCORES, "$form{'game'}ascores.dat");
while(<SCORES>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	push(@scores,$row);
}
close(SCORES);
foreach $score (@scores)
{
	@pieces = split(/\|/,$score);
	foreach $field (@fields)
	{
		$entry{$field} = $pieces[$number{$field}];
	}
	push(@nscores,&prepare_entry);
}
@scores = @nscores;
@nscores = ();
#Sort
if($properties{$fields[0]} == 1)
{
	@scores = sort sort_numbers @scores;
}
else
{
	@scores = sort sort_strings @scores;
}
#Save
open(SCORES, ">".$form{'game'}."ascores.dat");
foreach $score (@scores)
{
	print SCORES "$score\n";
}
close(SCORES);

########################################
# Read Universal Settings
########################################
open(SET,"uniset.dat");
$set = <SET>;
close(SET);
@unisettings = split(/,/,$set);
$help = $unisettings[2];

########################################
# Read and display page
########################################
$title = "Fields Saved";
open(PAGE, "nav.dat");
while(<PAGE>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$page = $page."$row\n";
}
close(PAGE);
eval($page);
}  #End else statement

########################################
# Prepare Entry to be added
########################################
sub prepare_entry
{
	$ready = "";
	foreach $field (@nfields)
	{
		$entry{$field} =~ s/\|/\&\#124/g;  #  Filter out pipes
		$entry{$field} =~ s/\n/\<br\>/g;  #  Filter out line breaks
		$ready = $ready.$entry{$field}."\|";
	}
	return $ready;
}

########################################
# Sort Subroutines
########################################
sub sort_strings
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return (uc($AArray[0]) cmp uc($BArray[0]));
}

sub sort_numbers
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return ($BArray[0] <=> $AArray[0]);
}