#!/usr/bin/perl

########################################
# Script by Matt of Bumderland
# http://www.bumderland.com
# bookbaghead@hotmail.com
########################################

########################################
# Display Header
########################################
print "Content-type: text/html\n\n";  #  Tells the browser that this is an HTML document

########################################
# Get Variables from Form
########################################
if($ENV{'CONTENT_LENGTH'} > 3)
{
	read (STDIN, $unformatted, $ENV{'CONTENT_LENGTH'});  #  stores the unformated form data
	@pairs = split(/&/,$unformatted);  #  splits up each pair (name=value)
	foreach $pair(@pairs)  #  starts loop to store each individual value
	{
		($name,$value) = split(/=/,$pair);  #  splits the name=value string into a string for each field
		$value =~ s/\+/ /g;  # converts plusses to spaces
		$value =~ s/%(..)/pack("c",hex($1))/ge;  #  converts special symbols (%20 to whatever)
		$form{lc($name)} = "$value";  #  defines form field
	}
}

########################################
# Check Password and Load Page Accordingly
########################################
$pass = crypt($form{'password'}, "MM");
open(USERS, "jxzdfx.dat");
$users = <USERS>;
close(USERS);
%users = split(/\,/,$users);
if($users{$form{'name'}} ne $pass)
{
	print "<html><head><title>Log-in Failed</title></head><body>Your username and/or password are invalid.</body></html>";
}
else
{
########################################
# Read Settings
########################################
open(SET,"$form{'game'}set.dat");
$set = <SET>;
close(SET);
@settings = split(/,/,$set);
$ini = $settings[10];  #How many scores to include in the generated INI file
$aini = $settings[11];  #For all-time scores

########################################
# Read Databases
########################################
if(substr($form{'type'},0,1) eq "a")
{
	open(SCORES, "$form{'game'}ascores.dat");
	while(<SCORES>)
	{
		$row = $_;
		$chopped = chop($row);
		if($chopped ne "\n")
			{$row = $row.$chopped;}
		push(@scores,$row);
	}
	close(SCORES);
}
else
{
	open(SCORES, "$form{'game'}scores.dat");
	while(<SCORES>)
	{
		$row = $_;
		$chopped = chop($row);
		if($chopped ne "\n")
			{$row = $row.$chopped;}
		push(@scores,$row);
	}
	close(SCORES);
}

########################################
# Get Field Data
########################################
open(FIELDS,"$form{'game'}fields.dat");
$properties = <FIELDS>;
close(FIELDS);
($fields,$properties) = split(/\|/,$properties);
@fields = split(/,/,$fields);
@properties = split(/,/,$properties);
$count = 0;
foreach $field (@fields)
{
	$properties{$field} = $properties[$count];
	$number{$field} = $count;  #  I need to know the numbers of cerain fields.
	$count++;
}
@properties = ();

########################################
# Sort Scores
########################################
if(!(exists $form{'sort'})){$form{'sort'} = $fields[0];}
if (($number{$form{'sort'}} ne "0") || (substr($query{'order'},0,1) eq "a"))
{	
	if($properties{$form{'sort'}} == 0)
	{
		if(substr($form{'order'},0,1) eq "a")
		{
			@scores = reverse sort sort_strings @scores;
		}
		else
		{
			@scores = sort sort_strings @scores;
		}
	}
	else
	{
		if(substr($form{'order'},0,1) eq "a")
		{
			@scores = reverse sort sort_numbers @scores;
		}
		else
		{
			@scores = sort sort_numbers @scores;
		}
	}
}

########################################
# Change Score
########################################
#Combine Fields
foreach $field (@fields)
{
	$form{$field} =~ s/\|/\&\#124/g;  #  Filter out pipes
	$form{$field} =~ s/\n/\<br\>/g;  #  Filter out line breaks
	$ready = $ready.$form{$field}."\|";
}
$scores[$form{'place'}] = $ready;
#Sort
$form{'sort'} = $fields[0];
if($properties{$fields[0]} == 1)
{
	@scores = sort sort_numbers @scores;
}
else
{
	@scores = sort sort_strings @scores;
}
#Save
if(substr($form{'type'},0,1) eq "a")
{
	open(SCORES, ">".$form{'game'}."ascores.dat");
	$ini = $aini;
	$aini = "a";
}
else
{
	open(SCORES, ">".$form{'game'}."scores.dat");
	$aini = "";
}
$count=0;
if($ini > 0)
{
	open(INI,">".$form{'game'}."scores.ini");
}
foreach $score (@scores)
{
	if(($ini > 0) && ($count<=$ini))
	{
		print INI "[".$aini.$count."]\n";
		@pieces = split(/\|/,$score);
		foreach $field (@fields)
		{
			if($field ne "secure")  #Sorry, no passing of security codes
			{
				print INI $field."=".$pieces[$number{$field}]."\n";
			}
		}
	}
	$count++;
	print SCORES "$score\n";
}
if($ini > 0)
{
	close(INI);
}
close(SCORES);

########################################
# Read Universal Settings
########################################
open(SET,"uniset.dat");
$set = <SET>;
close(SET);
@unisettings = split(/,/,$set);
$help = $unisettings[2];

########################################
# Read and display page
########################################
$title = "Entry Changed";
open(PAGE, "nav.dat");
while(<PAGE>)
{
	$row = $_;
	$chopped = chop($row);
	if($chopped ne "\n")
		{$row = $row.$chopped;}
	$page = $page."$row\n";
}
close(PAGE);
eval($page);
}  #  Ends else statement

########################################
# Sort Subroutines
########################################
sub sort_strings
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return (uc($AArray[$number{$form{'sort'}}]) cmp uc($BArray[$number{$form{'sort'}}]));
}

sub sort_numbers
{
	my(@AArray) = split(/\|/,$a);
	my(@BArray) = split(/\|/,$b);
	return ($BArray[$number{$form{'sort'}}] <=> $AArray[$number{$form{'sort'}}]);
}